---
title: Papers and Presentations
layout: page
tags: [legacy]
comments: true
redirect_from: /legacy/index.php/Papers_and_Presentations
---
#### Contents
{:.no_toc}
1. contents
{:toc}

## Presentations:

* [Thread Safety](figures/2008_09_11_thread_safety.pdf)\\
  An expanded version of the classes the work talk focusing on thread safety and covering locks and atomics.

* [Classes that Work: Copy and Assignment](figures/2008_06_26_classes_that_work.pdf)\\
  From an engineering boot camp at Adobe, June 26th, 2008. Shortened version of internal talk. Recording with Eric Berdahl presenting available [here](http://my.adobeconnect.com/p53888531/) [Recording no longer available].

* [Adobe Source Libraries: Overview & Philosophy](figures/2008_04_03_accu.pdf)\\
  From [ACCU 2008, April 3, 2008](http://www.accu.com/).

* [Science of 'Shrink Wrap': A Look Inside Adobe Photoshop](figures/2008_01_18_indiana_shrink_wrap.pdf)\\
  Presentation from January, 18th, 2008 at Indiana University revised from a talk given at Texas A&M.

* [A Possible Future of Software Development](figures/2008_07_25_google.pdf)\\
  Revised for [Google Tech Talks, July 25, 2007](https://www.youtube.com/user/googletechtalks). [Recorded Presentation](https://www.youtube.com/watch?v=4moyKUHApq4).

* [A Possible Future of Software Development](figures/Boostcon_possible_future.pdf)\\
  Revised for [http://cppnow.org/ BoostCon'07 Keynote, May 16, 2007].

* [Concept-Based Runtime Polymorphism](figures/Boost_poly.pdf)\\
  From [BoostCon'07, May 17, 2007](http://cppnow.org/).

* [A Possible Future of Software Development](figures/Possible_future.pdf)\\
  From [Library-Centric Software Design Workshop, OOPSLA, October 22, 2006](https://web.archive.org/web/20150404055433/http://lcsd.cs.tamu.edu/2006/).

* [Beyond Objects](figures/Regular_object_presentation.pdf)\\
  From [C++ Connections, November 2005](https://web.archive.org/web/20061026110121/https://www.devconnections.com/shows/CPPFall2005/default.asp?c=2&s=67).

## Publications:

* Algorithms for User Interfaces (http://www.emarcus.org/papers/gpce2009-marcus.pdf)\\
  Jaakko Järvi, Texas A&M University, Mat Marcus, Canyonlands Software Design, Sean Parent, Adobe Systems, Inc., John Freeman, Texas A&M University, and Jacob N. Smith, Texas A&M University\\
  From: GPCE '09 Proceedings of the 8th international conference on Generative programming and component engineering, New York, NY, USA, pages 147-156, 2009. ACM\\
  _Copyright ACM, 2009. This is the authors' version of the work. It is posted here by permission of ACM for your personal use. Not for redistribution. The definitive version was published in the Proceedings of the 8th International Conference on Generative Programming and Component Engineering (Denver, Colorado, October 4–5, 2009). GPCE 2009 <https://doi.acm.org/10.1145/1621607.1621630>_

* Runtime Concepts for the C++ Standard Template Library (Extended Version) (http://www.emarcus.org/papers/oops2008-marcus.pdf)\\
  Peter Pirkelbauer, Texas A&M University, Sean Parent, Adobe Systems, Inc., Mat Marcus, Adobe Systems, Inc., Bjarne Stroustrup, Texas A&M University\\
  From: Science of Computer Programming, 2009. To appear.

* Programming with C++ Concepts - \\
  Jaakko J&auml;rvi, Texas A&M University, Mat Marcus, Adobe Systems, Inc., and Jacob N. Smith, Texas A&M University\\
  From: Science of Computer Programming, 2008. To appear.

* Property Models: From Incidental Algorithms to Reusable Components (http://www.emarcus.org/papers/gpce2008-marcus.pdf)\\
  Jaakko J&auml;rvi, Texas A&M University, Mat Marcus, Adobe Systems, Inc., Sean Parent,  Adobe Systems, Inc., John Freeman, Texas A&M University, and Jacob N. Smith, Texas A&M University\\
  From: GPCE '08: Proceedings of the 7th international conference on Generative programming and component engineering, New York, NY, USA, pages 89-98, 2008. ACM\\
  _Copyright ACM, 2008. This is the authors' version of the work. It is posted here by permission of ACM for your personal use. Not for redistribution. The definitive version was published in the Proceedings of the 7th International Conference on Generative Programming and Component Engineering (Nashville, Tennessee, October 19–20, 2008). GPCE 2008 <https://doi.acm.org/10.1145/1449913.1449927>_

* Runtime Concepts for the C++ Standard Template Library (http://www.emarcus.org/papers/oops2008-marcus.pdf)\\
  Peter Pirkelbauer, Texas A&M University, Sean Parent, Adobe Systems, Inc., Mat Marcus, Adobe Systems, Inc., Bjarne Stroustrup, Texas A&M University\\
  From: Proceedings of the 2008 ACM symposium on Applied Computing, Special Track on Object Oriented Programming Languages and Systems\\
  _Copyright ACM, 2008. This is the authors' version of the work. It is posted here by permission of ACM for your personal use. Not for redistribution. The definitive version was published in the Proceedings of the 2008 ACM symposium on Applied Computing (Fortaleza, Brazil, March 16-20, 2008). SAC 2008 <https://doi.acm.org/10.1145/1363686.1363734>_

* Library Composition and Adaptation using C++ Concepts (http://www.emarcus.org/papers/gpce2007f-authors-version.pdf)\\
  Jaakko Järvi, Texas A&M University, Mat Marcus, Adobe Systems, Inc., Jacob N. Smith, Texas A&M University.\\
  From: Proceedings of the 6th international conference on Generative programming and component engineering, 2007.\\
  _Copyright ACM, 2007. This is the author's version of the work. It is posted here by permission of ACM for your personal use. Not for redistribution. The definitive version was published in the Proceedings of the 6th International Conference on Generative Programming and Component Engineering (Salzburg, Austria, October 01 - 03, 2007). GPCE '07 <https://doi.acm.org/10.1145/1289971.1289984>_

* Runtime Polymorphic Generic Programming--Mixing Objects and Concepts in ConceptC++ (http://www.emarcus.org/papers/MPOOL2007-marcus.pdf)\\
  Mat Marcus, Adobe Systems, Inc., Jaakko Järvi, Texas A&M University, Sean Parent, Adobe Systems, Inc.\\
  From: The 6th International Workshop on Multiparadigm Programming with Object-Oriented Languages at the ECOOP 2007. Slides (http://www.emarcus.org/papers/MPOOL2007-slides-marcus.pdf)

* Notes on Foundations of Programming I (http://www.emarcus.org/papers/PAM.pdf)\\
  Alex Stepanov and Mat Marcus, Adobe Systems, Inc.,\\
  Class notes 2004-2005

* Notes on Foundations of Programming II (http://www.emarcus.org/papers/FOP2.pdf)\\
  Alex Stepanov and Mat Marcus, Adobe Systems, Inc.,\\
  Class notes 2004-2005

* Simulating Partial Specialization (http://www.emarcus.org/papers/PartialSpecialization2000.pdf)\\
  Mat Marcus, Adobe Systems, Inc.<br /> From: the OOPSLA Workshop On Generative Programming 2001. Slides (http://www.emarcus.org/papers/PartialSpecSlides.pdf)\\
  See also [The Boost Type Traits Library](https://www.boost.org/doc/libs/1_64_0/libs/type_traits/doc/html/index.html)\\

* [How To Write A Simple Lexical Analyzer or Parser](how-to-write-a-simple-lexical-analyzer-or-parser.html)\\
  Sean Parent, Adobe Systems, Inc.

## Papers To Be Written:

* Generic Programming Definition and Terms
* Regular Concept Requirements
* Proxy Dilemma
* The Problem with Swap
* The Problem with Dereference
* Namespaces, ADL, and Modeling
* Namespaces, ADL, and Refinement
* Namespaces, ADL, and Versioning
* Object Oriented Programming in Generic Terms
* Functional Programming in Generic Terms

## Drafts and Sketches:

* [Runtime Concepts](runtime-concepts.html)
* [Dynamic Libraries](dynamic-libraries.html)
* [Representational Equality](representational-equality.html)
* [No virtual method "any" example](no-virtual-method-any-example.html)

## Proposals:
* [Prof. Lumsdaine Collaboration](prof.-lumsdaine-collaboration.html)
* [Conceptual C](conceptual-c.html)

## Collaboration:
* [Argument Against Garbage Collection in C++](argument-against-gc.html)
