---
title: Perforce Open Source License
layout: page
tags: [legacy]
comments: true
redirect_from: /legacy/index.php/Perforce_Open_Source_License
---
PERFORCE End User License Agreement for Open Source Software Development

#### Contents
{:.no_toc}
1. contents
{:toc}

## Introduction
This is a License Agreement (“Agreement”) between Perforce Software, Inc., a California
corporation (“Perforce”), and ________________________________________ (“Customer”),
in which Perforce grants Customer certain rights to use Perforce: The Fast Software
Configuration Management System, for the purpose of developing software to be distributed
under an Open Source License.

## Definitions

A. “Program” shall mean the machine-readable object code of the computer software program
or programs described in the Program Description attached as Attachment A to the
Agreement.

B. “Documentation” shall mean the user manual(s) and any other materials supplied or made
available by Perforce for use with the Program.

C. “Software” shall mean, collectively, the Program and the Documentation.

D. “Server” shall mean that component of the Program which accepts network connections
from other software programs and returns to such programs data managed by the Program,
or information about such data.

E. “License” shall mean Customer’s worldwide, nonexclusive right to use the Software which
is granted by this Agreement.

F. “License File” shall mean an ASCII file containing an encoded license string which enables
the Program to operate in a specified multi-user configuration.

G. “Delivery Date” shall mean the date that Perforce transfers or allows Customer to transfer a
License File for the Program to Customer’s location by electronic mail or file transfer over a
network.

H. “Per Human Being” shall describe that form of software license which restricts the
licensed software to being used by a specified maximum number of individual users,
irrespective of whether such use is concurrent.

I. “Open Source License” shall mean a licensing arrangement as described in Section 9 of
this Agreement.

J. A “Read-Only User” is a person who uses the Server in such a way as to be prevented by
the Server from changing the data managed by the Server.

## Items Provided by Perforce

A. Perforce shall furnish Customer with the Software, as it is described in Attachment A.
Program will be made available to be downloaded in machine-readable object code form by
electronic file transfer. The Documentation will be delivered electronically as machine
readable text files suitable for printing.  Customer may copy, print, or reproduce the
Documentation without restriction, provided that all copyright and other proprietary notices
are reproduced substantially similar to the originals.

B. Perforce shall furnish to Customer one copy of the Program modules for each computer on
which it is to run as designated in Attachment B.

C. Perforce shall furnish to Customer a License File which will enable the Program to operate
in the configuration specified in Attachment B.

D. Customer acknowledges and agrees that it has independently verified that the Software is
appropriate for the purposes for which Customer intends to use it, and that Customer did not
rely upon any skill or judgment of Perforce in such selection.

## Grants of License

A. Perforce hereby grants to Customer a world-wide non-exclusive license to use the Software
for Customer’s own direct use for the purpose of managing data distributed under an Open
Source License.

B. Customer may make any additional copies of the Software to the extent necessary for use of
the Program. In addition, Customer may copy the Software for archival or backup purposes.
Customer shall reproduce and include copyright or other proprietary notices on any copies in
substantially the same form as appears in or on the original copies provided to Customer.

C. The Program is configured by Perforce to support the number of users specified in
Attachment B. The Program is licensed on a Per Human Being basis, with the maximum
number of users permitted to use the Server being that quantity specified in Attachment B.
Customer understands that the Program enforces this limitation, and that any failure of the
Program to perform in conformance with the Documentation in response to users in excess
of the number specified in Attachment B is not a defect in the Program.

D. Notwithstanding any other provision of this Agreement, it is the intent of the parties that an
unlimited number of Read-Only Users be licensed to use the Program.

E. Perforce hereby reserves all rights in and to the Software that are not specifically granted by
this license Agreement.

## Software Support

A. The Program is provided “AS IS,” without any software support.

## Customer’s Obligations

A. The License is provided to Customer at no charge.

B. Customer agrees that all data managed by the Program will be distributed exclusively under
the Open Source License which appears in Attachment C.  Use of the Software for any other
purpose constitutes a material breach of this Agreement.

C. Customer will configure the Server to allow it to receive connections from software
programs running on Perforce’s computer systems, and to permit unrestricted access to any
Read-Only User who connects to Customer’s Server via such a connection.

## Warranties and Indemnification

A. Customer will indemnify and hold harmless Perforce, and all its successors in interest,
subsidiaries, affiliates, and their officers, employees and agents, from all liability arising
from use of the Software by Customer or by any successors in interest of Customer.

B. DISCLAIMER OF WARRANTY.  CUSTOMER RECEIVES THE SOFTWARE “AS
IS.” PERFORCE DISCLAIMS ALL WARRANTIES OR CONDITIONS OF ANY KIND,
EITHER EXPRESS OF IMPLIED, INCLUDING BUT NOT LIMITED TO ALL
WARRANTIES AND CONDITIONS OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE AND THOSE ARISING BY STATUTE OR OTHERWISE IN
LAW OR FROM A COURSE OF DEALING OR USAGE OR TRADE. OTHER
WRITTEN OR ORAL STATEMENTS BY PERFORCE, ITS REPRESENTATIVES OR
OTHERS DO NOT CONSTITUTE WARRANTIES OR CONDITIONS OF PERFORCE.
NOTHING STATED IN THIS AGREEMENT WILL IMPLY THAT THE OPERATION
OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE OR THAT
ERRORS WILL BE CORRECTED AT A PARTICULAR TIME. CUSTOMER ASSUMES
RESPONSIBILITY FOR THE SELECTION AND TESTING OF THE SOFTWARE TO
ACHEIVE CUSTOMER’S INTENDED RESULTS AND FOR THE INSTALLATION
USE AND RESULTS OBTAINED FROM IT. THESE LIMITATIONS DO NOT AFFECT
CUSTOMER’S STATUTORY RIGHTS AS A CONSUMER, IF ANY.

C. NO CONSEQUENTIAL DAMAGES. EXCEPT AS DESCRIBED IN PARAGRAPH
13(B) BELOW, NEITHER PARTY WILL BE LIABLE UNDER THIS AGREEMENT
UNDER ANY CONTRACT, NEGLIGENCE, STRICT LIABILITY OR OTHER LEGAL
OR EQUITABLE THEORY FOR ANY INDIRECT, SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES (INCLUDING DAMAGES FOR LOSS OF BUSINESS
AND LOSS OF PROFITS), EVEN IF IT HAS BEEN ADVISED OF THE POSSIBILITY
OF SUCH DAMAGES.

D. EXCLUSIVE REMEDY.  THE PROVISIONS OF THIS SECTION 7 STATE THE
EXCLUSIVE LIABILITY OF PERFORCE, AND THE EXCLUSIVE REMEDY OF
CUSTOMER, WITH RESPECT TO ANY CLAIM OF PATENT, COPYRIGHT, OR
TRADE SECRET INFRINGEMENT.

## Intellectual Property

A. Customer acknowledges and agrees that it obtains no ownership rights in the Software under
the terms of this Agreement, and that Perforce has and retains all right, title, interest and
ownership in and to the Software, and in any copies or updates of the Software whether
made by Customer or Perforce.

B. Customer acknowledges that the Software constitutes proprietary information and trade
secrets of Perforce, whether or not any portion of the Software is or may be the subject of a
valid copyright or patent.

C. Customer may not alter any proprietary markings on the Software, including copyright,
trademark, trade secret, and patent legends.

D. Any authorized copies of the Software made by Customer shall contain a reproduction or
equivalent of the copyright notice or other proprietary markings appearing on the Program
and Documentation delivered by Perforce.

E. Customer may not decompile, disassemble, or reverse engineer the Program.

F. Perforce shall retain the copyright to all enhancements to the Software.

## Open Source Licenses

A. An Open Source License is a licensing arrangement which, in the exclusive judgment of
Perforce, constitutes an open source license.

B. Perforce considers the following licensing agreements to be Open Source Licenses:

1. The GNU general public license, version 2

2. The GNU lesser general public license, version 2.1

3. The GNU library public license

4. A license consisting exclusively of the following language, verbatim: “Redistribution
and use in source and binary forms, with or without modification, are permitted.”

C. No licensing arrangement other than the ones enumerated in the previous paragraph
constitutes an Open Source License unless Perforce provides Customer with written notice
that the licensing arrangement, in Perforce’s judgment, constitutes an Open Source License.

## Term and Termination

A. Notwithstanding any other provision of this Agreement, any material breach of any
provision of this Agreement by Customer shall be grounds for immediate termination of this
Agreement and the License granted by it, without further obligation by Perforce to
Customer.

B. This Agreement shall be in effect for a term of one year, beginning on the Delivery Date and
ending on the first anniversary of the Delivery Date.

C. Upon expiration of this Agreement, Perforce may, at its option and its sole discretion, renew
this Agreement for a further term of one year. Perforce will not withhold such renewal
unreasonably. However, no provision of this Agreement shall be interpreted as a promise or
commitment by Perforce to renew this Agreement upon expiration of its one-year term.

D. The License granted by this Agreement shall be in effect only for so long as this Agreement
is in effect. Upon expiration or termination of this Agreement in any manner described
herein, all rights granted by Perforce to Customer under this Agreement, including the
License, shall revert to Perforce, and Customer shall have no further rights to use the
Software; provided, however, that all limitations and obligations under Sections 2, 7, 8, 11,
13, and 14 of this Agreement shall survive any termination or expiration of this Agreement,
and shall continue to bind the parties.

E. If Perforce notifies Customer in writing that this Agreement has terminated in any manner
described herein, Customer shall, within fifteen (15) days of such notice, (i) discontinue all
use of the Software; (ii) remove all copies of the Software contained in any computer
memory or data storage device under the control of Customer; and (iii) certify to Perforce in
writing that it has complied with the requirements of this Paragraph 10(E).

## Arbitration and Mediation

A. Except as described in Paragraph 13(B), if any dispute arises under the terms of this
Agreement, the parties agree to select a mutually agreeable neutral third party to help them
mediate it.  If the mediation is unsuccessful, the parties agree that the dispute shall be
decided by binding arbitration under the rules issued by the American Arbitration
Association.  The decision of the arbitrator shall be final. Costs and fees (other than
attorneys fees) associated with the mediation or arbitration shall be shared equally by the
parties.  Each party shall be responsible for its Attorneys’ fees associated with arbitration.

## Assignment, Delegation and Sublicensing
A. Customer may not sell, transfer, assign, delegate, subcontract, or sub-license the License, or
any other rights or obligations under this Agreement, without the prior written consent of
Perforce.

## Remedies

A. Liquidated Damages.  The parties agree that it would be would be impracticable or
extremely difficult to calculate Perforce’s damages in the event of a breach by Customer of
Customer’s obligations under Paragraph 6(B).  Therefore, the parties agree that a reasonable
measure of Perforce’s damages in the event of such a breach is the commercial price, as
published on Perforce’s World Wide Web site, of a commercial license for the use of the
Software by the number of users specified in Attachment B, including technical support fees
for one year.

B. Equitable Remedies.  The parties recognize that money damages may not be an adequate
remedy for any breach or of any obligation hereunder by Customer involving intellectual
property or use of the Program beyond the scope of the license granted by this Agreement.
The parties therefore agree that in addition to any other remedies available hereunder, by
law or otherwise, Perforce and any third party from whom Perforce has licensed software or
technology may be entitled to seek injunctive relief against any such continued breach by
Customer of such obligations.

## General

A. Applicable Law.  This Agreement shall be construed pursuant to substantive law of the
State of California, excluding any choice of law rules.

B. Public Reference. Customer consents to the public use of its name as a customer of
Perforce, unless Customer notifies Perforce in writing that it withholds such consent.

C. Modification.  This Agreement may not be modified or amended except by written notice
which is signed by authorized representatives of each of the parties.

D. No Waiver.  The failure of either party to exercise any right or the waiver by either party of
any breach, shall not prevent a subsequent exercise of such right or be deemed a waiver of
any subsequent breach of the same of any other term of the Agreement.

E. Exclusive Jurisdiction and Venue.  Any cause or action arising out of or related to this
Agreement, including an action to confirm or challenge an arbitration award, may only be
brought in the courts of applicable jurisdiction in California at Alameda County, and the
parties hereby submit to the jurisdiction and venue of such courts.

F. Written Notice.  Any written notice from one party to the other required by this Agreement
shall be deemed made on the date of mailing if sent by certified mail or overnight courier
and addressed to the address specified below.   Written notice sent by any other means shall
be deemed made on the date it is received by the party to whom it is directed.  Notice sent
by facsimile or by electronic mail shall not be deemed “written notice” as contemplated by
this Agreement.

G. Entire Agreement.  This Agreement, including its Attachments, constitutes the sole and
entire agreement of the parties with respect to the subject matter hereof and supersedes any
prior oral or written promises or agreements. There are no promises, covenants or
undertakings other than those expressly set forth in this Agreement.

H. No Election of Remedies.   The pursuit by either party of any remedy to which it is entitled
at any time shall not be deemed an election of remedies or waiver of the right to pursue any
other remedies to which it may be entitled.

I. Independent Contractors.  Nothing in this Agreement shall be deemed or construed by the
parties or by any other entity to create an agency, partnership or joint venture between
Customer and Perforce.

J. Severability.  If any provision of this Agreement or any Attachment hereto is held invalid or
otherwise unenforceable, the enforceability of the remaining provisions of this Agreement
and the Attachments will not be impaired thereby.

K. Attachments.  Attachments A, B and C hereto are incorporated into and made part of this
Agreement.
